
import ddf.minim.*;

Minim minim;
AudioInput in;
 
float newLevel = 0;
float oldLevel = 0;

void setup()
{
  size(200, 200, P2D);

  minim = new Minim(this);
  minim.debugOn();
  
  // get a line in from Minim, stereo, 16 samples
  in = minim.getLineIn(Minim.STEREO, 16);
}


void draw()
{
  background(0);
  stroke(255);
  
  // reset total and avg input level
  int totalInput = 0;
  int avgInput = 0;
  
  // calculate input average
  for(int i = 0; i < in.bufferSize() - 1; i++)
  {
   totalInput += (abs(in.left.get(i)) *200);
  }

  avgInput = totalInput / in.bufferSize();

  // use new average only if bigger than the old one
  if (avgInput > oldLevel){
    newLevel = avgInput;
  } else if (avgInput <= oldLevel){
    // if avgInput is not bigger, decrease the newLevel value
    newLevel = (oldLevel - 0.5); 
  }  
  
  // draw the average line
  line(0, (100 + newLevel), 200, (100 + newLevel));
  
  // store the actual level value as old level value
  oldLevel = newLevel;
  
}




void stop()
{
  // always close Minim audio classes when you are done with them
  in.close();
  minim.stop();
  
  super.stop();
}
